/**
 *     This file is part of the Squashtest platform.
 *     Copyright (C) Henix, henix.fr
 *
 *     See the NOTICE file distributed with this work for additional
 *     information regarding copyright ownership.
 *
 *     This is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU Lesser General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     this software is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU Lesser General Public License for more details.
 *
 *     You should have received a copy of the GNU Lesser General Public License
 *     along with this software.  If not, see <http://www.gnu.org/licenses/>.
 */

// Using on scss file to generate classes
// It's too painfull with less that ng-zorro has imposed to us...
// Generating justify-content classes for flex
$justify-contents: ('space-evenly', 'flex-start', 'flex-end', 'space-between', 'space-around', 'center');

@each $content in $justify-contents {
  .#{$content} {
    justify-content: #{$content};
  }
}

//Generating workspace color classes
$workspaces: ('requirement', 'test-case', 'campaign', 'custom-report', 'automation', 'bugtracker', 'administration');

@each $workspace in $workspaces {
  .#{$workspace}-workspace-main-color__background {
    background-color: var(--#{$workspace}-workspace-main-color);
  }

  .#{$workspace}-workspace-main-color__hover:hover {
    background-color: var(--#{$workspace}-workspace-main-color);
    cursor: pointer;
  }

  .#{$workspace}-workspace-svg-color {
    fill: var(--#{$workspace}-workspace-main-color);
  }

  .#{$workspace}-workspace-svg-color__hover :hover {
    fill: var(--#{$workspace}-workspace-main-color);
    cursor: pointer;
  }
}

//Generating workspace color alpha variables
$hues: ('darkest', 'darker', 'dark', 'main', 'bright', 'brighter', 'brightest');

@each $hue in $hues {

  //current workspace classes
  .current-workspace-#{$hue}-color {
    color: var(--current-workspace-#{$hue}-color);
  }

  .current-workspace-#{$hue}-color__background {
    background-color: var(--current-workspace-#{$hue}-color);
  }

}

//Generating margin and padding classes
$spaceamounts: (1, 2, 3, 4, 5, 6, 8, 10, 15, 20, 25, 30, 35, 40, 45, 50, 55, 60, 75, 100);
$sides: (top, bottom, left, right);
$corners: ('top-left', 'top-right', 'bottom-right', 'bottom-left');

@each $space in $spaceamounts {
  @each $side in $sides {
    .m-#{str-slice($side, 0, 1)}-#{$space} {
      margin-#{$side}: #{$space}px;
    }

    .p-#{str-slice($side, 0, 1)}-#{$space} {
      padding-#{$side}: #{$space}px;
    }

    .#{$side}-#{$space} {
      #{$side}: #{$space}px;
    }
  }
}


@each $space in $spaceamounts {
    .m-x-#{$space} {
        margin-left: #{$space}px;
        margin-right: #{$space}px;
    }

    .m-y-#{$space} {
        margin-top: #{$space}px;
        margin-bottom: #{$space}px;
    }

    .p-x-#{$space} {
        padding-left: #{$space}px;
        padding-right: #{$space}px;
    }

    .p-y-#{$space} {
        padding-top: #{$space}px;
        padding-bottom: #{$space}px;
    }
}


@each $space in $spaceamounts {
  .m-#{$space} {
    margin: #{$space}px;
  }

  .p-#{$space} {
    padding: #{$space}px;
  }
}

$font-sizes: (4, 6, 8, 10, 11, 12, 13, 14, 15, 16, 18, 20, 22, 24, 26, 28, 30, 32, 36, 40, 50);

@each $font-size in $font-sizes {
  .font-#{$font-size}-px {
    font-size: #{$font-size}px !important;
  }

}

